Description

There seems to be a bug in the MSSQL provider when accessed from python.

If you retrieve objects from a featurelayer with a QgsFeatureRequest, the filter expression ist not applied.

For example if you use this python code to retrieve features:

featReq=QgsFeatureRequest()

it = my_mssql_layer.getFeatures( featReq )

the resulting SQL Query as reported from SQL Server Profiler is:

select [objectid],... lots of columns ... ,[shape] from [dbo].[testpolygons]

Thats ok. It returns all features.

But if you add a filter expression:

featReq=QgsFeatureRequest()

featReq=featReq.setFilterExpression ('users>1')

my_feature_iterator = my_mssql_layer.getFeatures( featReq )

the resulting SQL is corrupt:

select [objectid],... lots of columns ... ,[shape] from [dbo].[flurstueck_f] where

[shape].STIntersects([geometry]::STGeomFromText('POLYGON((0.00000000 0.00000000, 0.00000000 0.00000000,

0.00000000 0.00000000, 0.00000000 0.00000000, 0.00000000 0.00000000))',25832)) = 1 and [objectid] = 30681189080760422

As you can see, a filter rectangle with unusable coordinates and an ID filter with a non existant id-number is applied.

This query returns nothing of course.

It seems that the FilterType of the QgsFeatureRequest is incorrectly interpreted as soon as the "setFilterExpression" is executed.

The result value of print featReq.filterType() befor the "setFilterExpression" is "0" and afterwards "3".

As I understand it, "3" is FilterType::FilterExpression, but the SQL Query is constructed as if the FilterType was "FilterRect" or something.

You can test this behavior by loading an MSSQL Layer in qgis and pasting following python code in the console:
(insert correct layername and filterexpression)

LegInt = iface.legendInterface()

layers = LegInt.layers()

for layer in layers:

    layerType = layer.type()

    if layer.name() == "testpolygone":

        my_mssql_layer=layer

        break

featReq=QgsFeatureRequest()

featReq=featReq.setFilterExpression ('users>1')

my_feature_iterator = my_mssql_layer.getFeatures( featReq )

for feature in my_feature_iterator:

    attrs = feature.attributes()

        print "Feature ID: " + str(feature.id()) + " " + str(attrs)

    break

I tested it in 2.2 and 2.4 on Windows.

I'm not shure which Category is correct for this issue. Perhaps rather "PyQGIS Console" ???

Associated revisions

Revision 7fe45db7 - 2014-09-09 08:44 PM - Jürgen Fischer

mssql provider: fix filter type interpretation (fixes #11076)

History

#1 - 2014-08-21 01:21 AM - Stefan Loehr

- Assignee set to Matthias Kuhn

The issue seems somehow related to #10900

#2 - 2014-09-09 11:28 AM - Jürgen Fischer

- Assignee deleted (Matthias Kuhn)

#3 - 2014-09-09 11:45 AM - Jürgen Fischer

- Status changed from Open to Closed

Fixed in changeset commit:"7fe45db70c7e5d583703b9e022e9c666237305a5".

#4 - 2014-09-09 11:22 PM - Jürgen Fischer

- Category changed from Data Provider to Data Provider/MSSQL
